package com.company;

import java.io.*;

public class Main {

    static final int NUM_PROCESOS = 4;
    static final String PREFIJO_FICHEROS = "resultado";

    public static void lanzarSumador(int n1, int n2,String ficheroResultados) throws IOException {
        String comando;
        //comando = "Sumador";
        comando = "com.company.Sumador";
        File carpeta;
        //carpeta = new File("./");
        carpeta = new File("./out/production/ComunicacionProcesos/");

        File fichero = new File(ficheroResultados);
        File errores = new File("errores.txt");
        ProcessBuilder pb;
        pb = new ProcessBuilder("java",
                comando,
                String.valueOf(n1),
                String.valueOf(n2) );
        pb.directory(carpeta);
        pb.redirectOutput(fichero);
        pb.redirectError(errores);
        pb.start();
    }

    public static int getResultadoFichero(String nombreFichero){
        int suma = 0;
        try {
            FileInputStream fis = new FileInputStream(nombreFichero);
            InputStreamReader isr = new InputStreamReader(fis);
            BufferedReader br = new BufferedReader(isr);
            String linea = br.readLine();
            suma = Integer.valueOf(linea);
        } catch (FileNotFoundException e) {
            System.out.println("No se pudo abrir " + nombreFichero);
        } catch (IOException e) {
            System.out.println("No hay nada en " + nombreFichero);
        } finally {
            return suma;
        }
    }

    public static long getSumaTotal(int n){
        long sumaTotal = 0;

        for (int i = 1; i <= n; i ++){
            sumaTotal += getResultadoFichero(PREFIJO_FICHEROS + String.valueOf(i) );
        }
        return sumaTotal;
    }

    public static void main(String[] args) throws IOException, InterruptedException {
        // write your code here
        int n1 = Integer.parseInt(args[0]);
        int n2 = Integer.parseInt(args[1]);
        float  salto = (n2 - (n1 - 1)) / Float.valueOf(NUM_PROCESOS);
        System.out.println("salto: " + salto);
        long sumaTotal;
        int inferior;
        float superior;

        inferior = n1;
        superior = n1 - 1 + salto;
        for (int i  = 1; i <= NUM_PROCESOS; i ++) {
            lanzarSumador(inferior, (int) superior, PREFIJO_FICHEROS + String.valueOf(i));
            System.out.println("Suma lanzada  . . . " + inferior + " - " + superior);
            inferior = (int)superior + 1;
            if (i == NUM_PROCESOS - 1) {
                superior = n2;
            } else {
                superior = superior + salto;
            }
        }

        Thread.sleep(1000);
        sumaTotal = getSumaTotal(NUM_PROCESOS);
        System.out.println("La suma total es: " + sumaTotal);
    }
}
